﻿#include "GameState.h"
#include "DllInterfaces/GFXAPI.h"
#include <Protocols.h>
#include "NetworkClient.h"
//#include "Camera.h"
#include <GameServerAPI.h>

using namespace ::DanBias::Client;
using namespace ::Oyster::Math3D;
using namespace ::Oyster::Math;

struct  GameState::myData
{
	myData(){}
	//std::vector<C_Object*> object;
	int modelCount;
	Oyster::Network::NetworkClient* nwClient;
	gameStateState state;
} privData;

GameState::GameState(void)
{
	key_forward = false;
	key_backward = false;
	key_strafeRight = false;
	key_strafeLeft = false;
}


GameState::~GameState(void)
{
	//delete this->camera;
	delete this->privData;
}
bool GameState::Init(Oyster::Network::NetworkClient* nwClient)
{
	// load models
	//camera = new Camera;
	privData = new myData();
	privData->state = gameStateState_loading;
	privData->nwClient = nwClient;	
	privData->state = LoadGame();
	//pitch = 0;

	//tELL SERver ready
	nwClient->Send(GameLogic::Protocol_General_Status(GameLogic::Protocol_General_Status::States_ready));

	return true;
}
GameState::gameStateState GameState::LoadGame() 
{
	Oyster::Graphics::Definitions::Pointlight plight;
	plight.Pos = Float3(315.0f, 0.0f ,5.0f);
	plight.Color = Float3(0.9f, 0.7f, 0.2f);
	plight.Radius = 100.0f;
	plight.Bright = 0.9f;
	Oyster::Graphics::API::AddLight(plight);
	plight.Pos = Float3(10.0f, 350.0f, 5.0f);
	plight.Color = Float3(0.9f, 0.7f, 0.3f);
	plight.Radius = 200.0f;
	plight.Bright = 0.7f;
	Oyster::Graphics::API::AddLight(plight);
	plight.Pos = Float3(350.0f, 350.0f, 5.0f);
	plight.Color = Float3(0.9f, 0.7f, 0.3f);
	plight.Radius = 200.0f;
	plight.Bright = 0.7f;
	Oyster::Graphics::API::AddLight(plight);
	plight.Pos = Float3(10.0f, 350.0f, 350.0f);
	plight.Color = Float3(0.9f, 0.7f, 0.3f);
	plight.Radius = 200.0f;
	plight.Bright = 0.7f;
	Oyster::Graphics::API::AddLight(plight);
	plight.Pos = Float3(10.0f, -15.0f, 5.0f);
	plight.Color = Float3(0.0f, 0.0f, 1.0f);
	plight.Radius = 50.0f;
	plight.Bright = 2.0f;

	Oyster::Graphics::API::AddLight(plight);
	// use level loader
	InitCamera( Float3(0.0f, 0.0f, 20.0f) );
	// hardcoded objects
	LoadModels();
	Float3 startPos = Float3(0,0,20.0f);
	InitCamera(startPos);
	return gameStateState_playing;
}
bool GameState::LoadModels()
{
	// open file
	// read file 
	// init models
	int nrOfBoxex = 5;
	int id = 100; 

	// add world model
	ModelInitData modelData;

	modelData.position = Float3(0,0,0);
	modelData.rotation = Quaternion::identity;
	modelData.scale =  Float3(2,2,2);

	modelData.modelPath = L"world_earth.dan";
	modelData.id = id++;

	this->staticObjects.Push(new C_StaticObj());
	this->staticObjects[this->staticObjects.Size() -1 ]->Init(modelData);


	// add box model
	modelData.position = Float3(0,0,0);
	modelData.rotation = Quaternion::identity;
	modelData.scale =  Float3(1,1,1);
	modelData.modelPath = L"crate_colonists.dan";


	for(int i =0; i< nrOfBoxex; i ++)
	{
		modelData.position = Float3(4,320,0);
		modelData.id = id++;

		this->dynamicObjects.Push(new C_DynamicObj());
		this->dynamicObjects[this->dynamicObjects.Size() -1 ]->Init(modelData);
	}


	// add crystal model 
	modelData.position = Float3(10, 301, 0);
	modelData.modelPath = L"crystalformation_b.dan";
	modelData.id = id++;
	// load models
	this->dynamicObjects.Push(new C_DynamicObj());
	this->dynamicObjects[this->dynamicObjects.Size() -1 ]->Init(modelData);

	// add house model 
	modelData.position = Float3(-50, 290, 0);
	//Oyster::Math3D::Float4x4 rot = Oyster::Math3D::RotationMatrix(Float3(0 ,Utility::Value::Radian(90.0f), 0));

	modelData.visible = true;
	modelData.modelPath = L"building_corporation.dan";
	modelData.id = id++;
	// load models
	this->dynamicObjects.Push(new C_DynamicObj());
	this->dynamicObjects[this->dynamicObjects.Size() -1 ]->Init(modelData);


	// add player model
	modelData.position = Float3(0, 320, 0);
	modelData.modelPath = L"char_still_sizeref.dan";
	modelData.id = id++;
	// load models
	this->dynamicObjects.Push(new C_DynamicObj());
	this->dynamicObjects[this->dynamicObjects.Size() -1 ]->Init(modelData);

	// add player model 2
	modelData.position = Float3(50, 320, 0);
	modelData.modelPath = L"char_still_sizeref.dan";
	modelData.id = id++;
	// load models
	this->dynamicObjects.Push(new C_DynamicObj());
	this->dynamicObjects[this->dynamicObjects.Size() -1 ]->Init(modelData);

	// add jumppad
	modelData.position = Float3(4.0f, 300.3f, 0.0f);
	modelData.modelPath = L"jumppad_round.dan";
	modelData.id = id++;
	// load models
	this->dynamicObjects.Push(new C_DynamicObj());
	this->dynamicObjects[this->dynamicObjects.Size() -1 ]->Init(modelData);

	// add sky sphere
	modelData.position = Float3(0,0,0);
	modelData.scale =  Float3(800,800,800);
	modelData.modelPath = L"skysphere.dan";
	modelData.id = id++;
	// load models
	this->dynamicObjects.Push(new C_DynamicObj());
	this->dynamicObjects[this->dynamicObjects.Size() -1 ]->Init(modelData);
	return true;
}
bool GameState::LoadModels(std::string mapFile)
{
	GameLogic::LevelLoader levelLoader;
	std::vector<Utility::DynamicMemory::SmartPointer<GameLogic::ObjectTypeHeader>> objects; 
	objects = levelLoader.LoadLevel(mapFile);

	int objCount = objects.size();
	int modelId = 0;
	ModelInitData modelData;
	for (int i = 0; i < objCount; i++)
	{
		GameLogic::ObjectTypeHeader* obj = objects.at(i);

		switch (obj->typeID)
		{
		case GameLogic::ObjectType::ObjectType_LevelMetaData:

			break;
		case GameLogic::ObjectType::ObjectType_Static:
			{
				GameLogic::ObjectHeader* staticObjData = ((GameLogic::ObjectHeader*)obj);

				modelData.modelPath.assign(staticObjData->ModelFile.begin(), staticObjData->ModelFile.end());
				modelData.visible = true;
				//modelData.position = ;
				//modelData.rotation = Quaternion(Float3(2,2,-2), 1);
				//modelData.scale =  Float3(2,2,2);
				modelData.id = modelId++;

				this->staticObjects.Push(new C_StaticObj());
				this->staticObjects[this->staticObjects.Size() -1 ]->Init(modelData);
			}
		break;
		case GameLogic::ObjectType::ObjectType_Dynamic:
			{
				GameLogic::ObjectHeader* dynamicObjData = ((GameLogic::ObjectHeader*)obj);
				//modelData.position = ;
				//modelData.rotation = Quaternion(Float3(2,2,-2), 1);
				//modelData.scale =  Float3(2,2,2);
				modelData.modelPath.assign(dynamicObjData->ModelFile.begin(), dynamicObjData->ModelFile.end());
				modelData.visible = true;
				modelData.id = modelId++;

				this->dynamicObjects.Push(new C_DynamicObj());
				this->dynamicObjects[this->dynamicObjects.Size() -1 ]->Init(modelData);
			}
			break;
		case  GameLogic::ObjectType::ObjectType_Light:
			{
				GameLogic::BasicLight* lightData = ((GameLogic::BasicLight*)obj);

				if(lightData->lightType == GameLogic::LightType_PointLight)
				{
					Oyster::Graphics::Definitions::Pointlight plight;
					plight.Pos = ((GameLogic::PointLight*)lightData)->position;
					plight.Color = lightData->diffuseColor;
					plight.Radius = 100;
					plight.Bright = 0.9f;
					Oyster::Graphics::API::AddLight(plight);
				}
			}
			break;
		default:
			break;
		}
	}
	myId += modelId++;
	// add player model
	//modelData.position = ;
	//modelData.rotation = Quaternion(Float3(2,2,-2), 1);
	//modelData.scale =  Float3(2,2,2);


	modelData.visible = true;
	modelData.modelPath = L"char_still_sizeref.dan";
	modelData.id = myId;
	// load models
	this->dynamicObjects.Push(new C_DynamicObj());
	this->dynamicObjects[this->dynamicObjects.Size() -1 ]->Init(modelData);

	/*C_Player* obj =  new C_Player();
	privData->object.push_back(obj);
	privData->object[privData->object.size() -1 ]->Init(modelData);
	*/
	return true;
	
}
bool GameState::InitCamera( Float3 startPos )
{
	camera.SetHeadOffset( Float3(0.0f, 1.0f, -2.0f) );
	//Float3 dir = Float3(0,0,1);
	//Float3 up = Float3(0,1,0);
	//Float3 pos = Float3(0, 0, 20);

	//camera->LookAt(pos, dir, up);
	//camera->SetLens(3.14f/2, 1024/768, 1, 1000);

	camera.SetPerspectiveProjection( pi/2.0f, 1024.0f/768.0f, 1.0f, 1000.0f );
	Oyster::Graphics::API::SetProjection( Float4x4(camera.GetProjectionMatrix()) ); // TODO: remove copy wrapper when no longer needed

	//camera->LookAt(pos, dir, up);
	//camera->SetLens(3.14f/2, 1024/768, 1, 1000);

	//privData->proj = Oyster::Math3D::ProjectionMatrix_Perspective(pi/4,1024.0f/768.0f,.1f,1000);

	//camera->UpdateViewMatrix();
	//privData->view = camera->View();
	//privData->view = Oyster::Math3D::ViewMatrix_LookAtDirection(Float3(0,0,-1),Float3(0,1,0),startPos);
	//privData->view = Oyster::Math3D::OrientationMatrix_LookAtDirection(Float3(0,0,-1),Float3(0,1,0),startPos);
	//Oyster::Graphics::API::SetProjection(camera->Proj());
	
	//privData->view = Oyster::Math3D::InverseOrientationMatrix(privData->view);
	return true;
}

void GameState::InitiatePlayer(int id, std::wstring modelName, Float4x4 world)
{
	myId = id;

	ModelInitData modelData;
	C_Object* obj;
	modelData.visible = true;
	//modelData.world = world;
	modelData.position = Float3(world[12], world[13], world[14]);
	modelData.rotation = Quaternion(Float3(0,0,0), 1);
	modelData.scale =  Float3(1,1,1);
	modelData.modelPath = modelName;
	modelData.id = myId;
	
	obj =  new C_Player();
	this->dynamicObjects.Push(obj);
	this->dynamicObjects[this->dynamicObjects.Size() -1 ]->Init(modelData);

	
	Float3 right = Float3(world[0], world[1], world[2]);
	Float3 up = Float3(world[4], world[5], world[6]);
	Float3 objForward = (Float3(world[8], world[9], world[10]));
	Float3 pos = Float3(world[12], world[13], world[14]);

	//Float3 cameraLook = camera->GetLook();
	//Float3 cameraUp = camera->GetUp();
				
	/*Float3 newUp = cameraUp.Dot(up);
	up *= newUp;
	up.Normalize();
	Float3 newLook = up.Cross(right);
	newLook.Normalize();*/

	//camera->setRight(right);
	//camera->setUp(up);
	//camera->setLook(objForward);
				
	//up *= 2;
	//objForward *= -3;
	//Float3 cameraPos = up + pos + objForward;
	//camera->SetPosition(cameraPos);

	//camera->UpdateViewMatrix();
	
}

GameClientState::ClientState GameState::Update(float deltaTime, InputClass* KeyInput)
{
	switch (privData->state)
	{
	case gameStateState_loading:	//Will this ever happen in this scope??
		{
			// load map
			// wait for all players
			LoadGame();
			GameLogic::Protocol_General_Status gameStatus;
			gameStatus.status = GameLogic::Protocol_General_Status::States_ready;
			privData->nwClient->Send(gameStatus);
			privData->state = gameStateState_playing;
		}
		break;
	case gameStateState_playing:
		// read server data
		// update objects
		{
			readKeyInput(KeyInput);
			camera.UpdateOrientation();
			//camera->UpdateViewMatrix();

		}
		break;
	case gameStateState_end:
		return ClientState_Lobby;
		break;
	default:
		break;
	}
	
	// send key input to server. 
	return ClientState_Same;
}
bool GameState::Render()
{
	Oyster::Graphics::API::SetView( camera.GetViewMatrix() );

	//Oyster::Graphics::API::SetView(camera->View());
	//Oyster::Graphics::API::SetProjection(camera->Proj());
	//Oyster::Graphics::API::SetView(privData->view);
	//Oyster::Graphics::API::SetProjection(privData->proj);

	Oyster::Graphics::API::NewFrame();
	for (unsigned int i = 0; i < staticObjects.Size(); i++)
	{
		staticObjects[i]->Render();
	}
	for (unsigned int i = 0; i < dynamicObjects.Size(); i++)
	{
		dynamicObjects[i]->Render();
	}

	Oyster::Graphics::API::EndFrame();
	return true;
}
bool GameState::Release()
{
	/*for (unsigned int i = 0; i < privData->object.size(); i++)
	{
	privData->object[i]->Release();
	delete privData->object[i];
	privData->object[i] = NULL;
	}*/

	delete privData;  
	privData = NULL;
	return true;
}
void GameState::readKeyInput(InputClass* KeyInput)
{

	bool send = false;
	GameLogic::Protocol_PlayerMovement movePlayer;
	movePlayer.bForward = false;
	movePlayer.bBackward = false;
	movePlayer.bLeft = false;
	movePlayer.bRight = false;

	if(KeyInput->IsKeyPressed(DIK_W))
	{

		if(!key_forward)
		{
			movePlayer.bForward = true;
			send = true;
			key_forward = true;
		}
	}
	else
		key_forward = false;

	if(KeyInput->IsKeyPressed(DIK_S))
	{
		if(!key_backward)
		{
			movePlayer.bBackward = true;
			send = true;
			key_backward = true;
		}
	}
	else 
		key_backward = false;

	if(KeyInput->IsKeyPressed(DIK_A))
	{
		if(!key_strafeLeft)
		{
			movePlayer.bLeft = true;
			send = true;
			key_strafeLeft = true;
		}
	}
	else 
		key_strafeLeft = false;

	if(KeyInput->IsKeyPressed(DIK_D))
	{
		if(!key_strafeRight)
		{
			movePlayer.bRight = true;
			send = true;
			key_strafeRight = true;
		}
	} 
	else 
		key_strafeRight = false;


	if (privData->nwClient->IsConnected() && send)
	{
		privData->nwClient->Send(movePlayer);
	}

	//send delta mouse movement 
	//if (KeyInput->IsMousePressed())
	{
		camera.YawRight( KeyInput->GetYaw() );
		camera.PitchUp( KeyInput->GetPitch() );
		camera.UpdateOrientation();

		//camera->Yaw(-KeyInput->GetYaw());
		//->Pitch(KeyInput->GetPitch());
		//pitch = KeyInput->GetPitch();
		//camera->UpdateViewMatrix();
		GameLogic::Protocol_PlayerLook playerLookDir;
		Float4 look = Float4( camera.GetLook(), 0.0f );
		//Float4 look = camera->GetLook();
		playerLookDir.lookDirX = look.x;
		playerLookDir.lookDirY = look.y;
		playerLookDir.lookDirZ = look.z;
		playerLookDir.deltaX = -KeyInput->GetYaw();

		privData->nwClient->Send( playerLookDir );
	}

	// shoot
	if(KeyInput->IsKeyPressed(DIK_Z))
	{
		if(!key_Shoot)
		{
			GameLogic::Protocol_PlayerShot playerShot;
			playerShot.primaryPressed = true;
			playerShot.secondaryPressed = false;
			playerShot.utilityPressed = false;
			privData->nwClient->Send(playerShot);
			key_Shoot = true;
		}
	} 
	else 
		key_Shoot = false;
	if(KeyInput->IsKeyPressed(DIK_X))
	{
		if(!key_Shoot)
		{
			GameLogic::Protocol_PlayerShot playerShot;
			playerShot.primaryPressed = false;
			playerShot.secondaryPressed = true;
			playerShot.utilityPressed = false;
			privData->nwClient->Send(playerShot);
			key_Shoot = true;
		}
	} 
	else 
		key_Shoot = false;
	if(KeyInput->IsKeyPressed(DIK_C))
	{
		if(!key_Shoot)
		{
			GameLogic::Protocol_PlayerShot playerShot;
			playerShot.primaryPressed = false;
			playerShot.secondaryPressed = false;
			playerShot.utilityPressed = true;
			privData->nwClient->Send(playerShot);
			key_Shoot = true;
		}
	} 
	else 
		key_Shoot = false;

	// jump
	if(KeyInput->IsKeyPressed(DIK_SPACE))
	{
		if(!key_Jump)
		{
			GameLogic::Protocol_PlayerJump playerJump;
			playerJump.hasJumped = true;
			privData->nwClient->Send(playerJump);
			key_Jump = true;
		}
	}
	else 
		key_Jump = false;

	// send event data
	//  
	if(KeyInput->IsKeyPressed(DIK_L))
		privData->state = GameState::gameStateState_end;
}

void GameState::Protocol(ProtocolStruct* pos)
{
	
}

void GameState::Protocol( PlayerPos* pos )
{
	//Float4x4 world, translate;

	//world = Float4x4::identity;
	//translate = Float4x4::identity;
	//translate = Oyster::Math3D::TranslationMatrix(Float3(pos->playerPos[0],pos->playerPos[1],pos->playerPos[2]));
	//world = world * translate;
	////privData->object[0]->setPos( world );
	//for (unsigned int i = 0; i < dynamicObjects.Size(); i++)
	//{
	//	dynamicObjects[i]->Render();
	//}
}

void GameState::Protocol( ObjPos* pos )
{
	Float4x4 world;
	for(int i = 0; i<16; i++)
	{
		world[i] = pos->worldPos[i];
	}
	//printf("pos for obj %d, ",pos->object_ID );
	for (unsigned int i = 0; i < dynamicObjects.Size(); i++)
	{
		if(dynamicObjects[i]->GetId() == pos->object_ID)
		{

			dynamicObjects[i]->setPos(Float3(world[12], world[13], world[14]));


			if(dynamicObjects[i]->GetId() == myId) // playerobj
			{
				Float3 right =		Float3(world[0], world[1], world[2]);
				Float3 up =			Float3(world[4], world[5], world[6]);
				Float3 objForward = Float3(world[8], world[9], world[10]);
				Float3 pos =		Float3(world[12], world[13], world[14]);

				//Float3 cameraLook = camera->GetLook();
				//Float3 cameraUp = camera->GetUp();

				/*Float3 newUp = cameraUp.Dot(up);
				up *= newUp;
				up.Normalize();
				Float3 newLook = up.Cross(right);
				newLook.Normalize();*/


				//camera->setRight(right);
				//camera->setUp(up);
				//camera->setLook(objForward);
				
				up *= 1;
				objForward *= -2;
				Float3 cameraPos = pos + up + objForward;
				//camera->SetPosition(cameraPos);
				//camera->UpdateViewMatrix();
				
			}
		}
	}
}

void GameState::Protocol( NewObj* newObj )
{

	Float4x4 world;
	for(int i = 0; i<16; i++)
	{
		world[i] = newObj->worldPos[i];
	}
	ModelInitData modelData;

	//modelData.world = world;
	modelData.visible = true;
	modelData.id = newObj->object_ID;
	//not sure if this is good parsing rom char* to wstring
	const char* path = newObj->path;
	modelData.modelPath = std::wstring(path, path + strlen(path));  
	// load models
	C_DynamicObj* player = new C_DynamicObj();
	player->Init(modelData);

	dynamicObjects.Push(player);

}

void DanBias::Client::GameState::Protocol( RemoveObj* obj )
{
	for (unsigned int i = 0; i < dynamicObjects.Size(); i++)
	{
		if(dynamicObjects[i]->GetId() == obj->object_ID)
		{
			//dynamicObjects[i]->Release();
			dynamicObjects[i].Release();
			//dynamicObjects.erase(privData->object.begin() + i );
		}
	}
	//privData->object[obj->object_ID]->Release( );
}

//void GameState::Protocol(LightPos pos);